//#include "bar.h"

#define uint16_t unsigned int
#define int16_t int
#define int32_t long int

typedef struct
{
  //int32_t e;
  uint16_t Kp, Ki, Kd;
} PID;

typedef struct process{
  float T,T1,a,b,K;
  int16_t y[10], u[10], e, eold; // max tau = 8*T
  int N;
  //BAR* ptrbar;
} PROCESS;

void process_set(PROCESS* p, float T, int16_t N1, float T1, float K);
void pid_set(PID* pid, PROCESS* p, float Kp, float Ti, float Td);
int16_t error(PROCESS* p, int16_t x);
int16_t pid(PROCESS* p, PID* pid);
int16_t process(PROCESS* p);
void process_shift(PROCESS* p);