
_process_set:

;PID.C,27 :: 		void process_set(PROCESS* p, float T, int16_t N1, float T1, float K)
;PID.C,29 :: 		p->e=0; p->eold=0;
	MOVLW       60
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	MOVLW       62
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;PID.C,30 :: 		p->T=T;
	MOVFF       FARG_process_set_p+0, FSR1L
	MOVFF       FARG_process_set_p+1, FSR1H
	MOVF        FARG_process_set_T+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_process_set_T+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_process_set_T+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_process_set_T+3, 0 
	MOVWF       POSTINC1+0 
;PID.C,31 :: 		p->N=N1;
	MOVLW       64
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_process_set_N1+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_process_set_N1+1, 0 
	MOVWF       POSTINC1+0 
;PID.C,32 :: 		p->T1=T1;
	MOVLW       4
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_process_set_T1+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_process_set_T1+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_process_set_T1+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_process_set_T1+3, 0 
	MOVWF       POSTINC1+0 
;PID.C,33 :: 		p->K=K;
	MOVLW       16
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_process_set_K+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_process_set_K+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_process_set_K+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_process_set_K+3, 0 
	MOVWF       POSTINC1+0 
;PID.C,34 :: 		p->a=exp(-(p->T)/(p->T1));
	MOVLW       8
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FLOC__process_set+0 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FLOC__process_set+1 
	MOVFF       FARG_process_set_p+0, FSR0L
	MOVFF       FARG_process_set_p+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVLW       0
	XORWF       R0, 0 
	MOVWF       R8 
	MOVLW       0
	XORWF       R1, 0 
	MOVWF       R9 
	MOVLW       128
	XORWF       R2, 0 
	MOVWF       R10 
	MOVLW       0
	XORWF       R3, 0 
	MOVWF       R11 
	MOVLW       4
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FSR2L 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R4 
	MOVF        POSTINC2+0, 0 
	MOVWF       R5 
	MOVF        POSTINC2+0, 0 
	MOVWF       R6 
	MOVF        POSTINC2+0, 0 
	MOVWF       R7 
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R10, 0 
	MOVWF       R2 
	MOVF        R11, 0 
	MOVWF       R3 
	CALL        _Div_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_exp_x+0 
	MOVF        R1, 0 
	MOVWF       FARG_exp_x+1 
	MOVF        R2, 0 
	MOVWF       FARG_exp_x+2 
	MOVF        R3, 0 
	MOVWF       FARG_exp_x+3 
	CALL        _exp+0, 0
	MOVFF       FLOC__process_set+0, FSR1L
	MOVFF       FLOC__process_set+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
	MOVF        R2, 0 
	MOVWF       POSTINC1+0 
	MOVF        R3, 0 
	MOVWF       POSTINC1+0 
;PID.C,35 :: 		p->b=(p->K)*(1-(p->a));
	MOVLW       12
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FLOC__process_set+4 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FLOC__process_set+5 
	MOVLW       16
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__process_set+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__process_set+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__process_set+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__process_set+3 
	MOVLW       8
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FSR2L 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R4 
	MOVF        POSTINC2+0, 0 
	MOVWF       R5 
	MOVF        POSTINC2+0, 0 
	MOVWF       R6 
	MOVF        POSTINC2+0, 0 
	MOVWF       R7 
	MOVLW       0
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVLW       127
	MOVWF       R3 
	CALL        _Sub_32x32_FP+0, 0
	MOVF        FLOC__process_set+0, 0 
	MOVWF       R4 
	MOVF        FLOC__process_set+1, 0 
	MOVWF       R5 
	MOVF        FLOC__process_set+2, 0 
	MOVWF       R6 
	MOVF        FLOC__process_set+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVFF       FLOC__process_set+4, FSR1L
	MOVFF       FLOC__process_set+5, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
	MOVF        R2, 0 
	MOVWF       POSTINC1+0 
	MOVF        R3, 0 
	MOVWF       POSTINC1+0 
;PID.C,36 :: 		for(i=0; i<=p->N; i++)
	CLRF        PID_i+0 
	CLRF        PID_i+1 
L_process_set0:
	MOVLW       64
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       FSR2L 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
	MOVF        PID_i+1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__process_set7
	MOVF        PID_i+0, 0 
	SUBWF       R1, 0 
L__process_set7:
	BTFSS       STATUS+0, 0 
	GOTO        L_process_set1
;PID.C,38 :: 		p->y[i]=p->u[i]=0;
	MOVLW       20
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       R4 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       R5 
	MOVF        PID_i+0, 0 
	MOVWF       R6 
	MOVF        PID_i+1, 0 
	MOVWF       R7 
	RLCF        R6, 1 
	BCF         R6, 0 
	RLCF        R7, 1 
	MOVF        R6, 0 
	ADDWF       R4, 0 
	MOVWF       R2 
	MOVF        R7, 0 
	ADDWFC      R5, 0 
	MOVWF       R3 
	MOVLW       40
	ADDWF       FARG_process_set_p+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      FARG_process_set_p+1, 0 
	MOVWF       R1 
	MOVF        R6, 0 
	ADDWF       R0, 1 
	MOVF        R7, 0 
	ADDWFC      R1, 1 
	MOVFF       R0, FSR1L
	MOVFF       R1, FSR1H
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	MOVFF       R0, FSR0L
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVFF       R2, FSR1L
	MOVFF       R3, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;PID.C,36 :: 		for(i=0; i<=p->N; i++)
	INFSNZ      PID_i+0, 1 
	INCF        PID_i+1, 1 
;PID.C,39 :: 		}
	GOTO        L_process_set0
L_process_set1:
;PID.C,40 :: 		}
L_end_process_set:
	RETURN      0
; end of _process_set

_pid_set:

;PID.C,42 :: 		void pid_set(PID* pid, PROCESS* p, float Kp, float Ti, float Td)
;PID.C,45 :: 		T=p->T;
	MOVFF       FARG_pid_set_p+0, FSR0L
	MOVFF       FARG_pid_set_p+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       pid_set_T_L0+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       pid_set_T_L0+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       pid_set_T_L0+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       pid_set_T_L0+3 
;PID.C,47 :: 		pid->Kp=1024*Kp;
	MOVF        FARG_pid_set_pid+0, 0 
	MOVWF       FLOC__pid_set+0 
	MOVF        FARG_pid_set_pid+1, 0 
	MOVWF       FLOC__pid_set+1 
	MOVLW       0
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVLW       137
	MOVWF       R3 
	MOVF        FARG_pid_set_Kp+0, 0 
	MOVWF       R4 
	MOVF        FARG_pid_set_Kp+1, 0 
	MOVWF       R5 
	MOVF        FARG_pid_set_Kp+2, 0 
	MOVWF       R6 
	MOVF        FARG_pid_set_Kp+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	CALL        _Double2Word+0, 0
	MOVFF       FLOC__pid_set+0, FSR1L
	MOVFF       FLOC__pid_set+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;PID.C,48 :: 		pid->Ki=1024*Kp*T/Ti;
	MOVLW       2
	ADDWF       FARG_pid_set_pid+0, 0 
	MOVWF       FLOC__pid_set+0 
	MOVLW       0
	ADDWFC      FARG_pid_set_pid+1, 0 
	MOVWF       FLOC__pid_set+1 
	MOVLW       0
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVLW       137
	MOVWF       R3 
	MOVF        FARG_pid_set_Kp+0, 0 
	MOVWF       R4 
	MOVF        FARG_pid_set_Kp+1, 0 
	MOVWF       R5 
	MOVF        FARG_pid_set_Kp+2, 0 
	MOVWF       R6 
	MOVF        FARG_pid_set_Kp+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        pid_set_T_L0+0, 0 
	MOVWF       R4 
	MOVF        pid_set_T_L0+1, 0 
	MOVWF       R5 
	MOVF        pid_set_T_L0+2, 0 
	MOVWF       R6 
	MOVF        pid_set_T_L0+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        FARG_pid_set_Ti+0, 0 
	MOVWF       R4 
	MOVF        FARG_pid_set_Ti+1, 0 
	MOVWF       R5 
	MOVF        FARG_pid_set_Ti+2, 0 
	MOVWF       R6 
	MOVF        FARG_pid_set_Ti+3, 0 
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	CALL        _Double2Word+0, 0
	MOVFF       FLOC__pid_set+0, FSR1L
	MOVFF       FLOC__pid_set+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;PID.C,49 :: 		pid->Kd=1024*Kp*Td/T;
	MOVLW       4
	ADDWF       FARG_pid_set_pid+0, 0 
	MOVWF       FLOC__pid_set+0 
	MOVLW       0
	ADDWFC      FARG_pid_set_pid+1, 0 
	MOVWF       FLOC__pid_set+1 
	MOVLW       0
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVLW       137
	MOVWF       R3 
	MOVF        FARG_pid_set_Kp+0, 0 
	MOVWF       R4 
	MOVF        FARG_pid_set_Kp+1, 0 
	MOVWF       R5 
	MOVF        FARG_pid_set_Kp+2, 0 
	MOVWF       R6 
	MOVF        FARG_pid_set_Kp+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        FARG_pid_set_Td+0, 0 
	MOVWF       R4 
	MOVF        FARG_pid_set_Td+1, 0 
	MOVWF       R5 
	MOVF        FARG_pid_set_Td+2, 0 
	MOVWF       R6 
	MOVF        FARG_pid_set_Td+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        pid_set_T_L0+0, 0 
	MOVWF       R4 
	MOVF        pid_set_T_L0+1, 0 
	MOVWF       R5 
	MOVF        pid_set_T_L0+2, 0 
	MOVWF       R6 
	MOVF        pid_set_T_L0+3, 0 
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	CALL        _Double2Word+0, 0
	MOVFF       FLOC__pid_set+0, FSR1L
	MOVFF       FLOC__pid_set+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;PID.C,50 :: 		}
L_end_pid_set:
	RETURN      0
; end of _pid_set

_error:

;PID.C,52 :: 		int16_t error(PROCESS* p, int16_t x)
;PID.C,55 :: 		N=p->N;
	MOVLW       64
	ADDWF       FARG_error_p+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_error_p+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R5 
	MOVF        POSTINC0+0, 0 
	MOVWF       R6 
;PID.C,56 :: 		p->e=x-(p->y[N]);
	MOVLW       60
	ADDWF       FARG_error_p+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_error_p+1, 0 
	MOVWF       FSR1H 
	MOVLW       20
	ADDWF       FARG_error_p+0, 0 
	MOVWF       R3 
	MOVLW       0
	ADDWFC      FARG_error_p+1, 0 
	MOVWF       R4 
	MOVF        R5, 0 
	MOVWF       R0 
	MOVF        R6, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R3, 0 
	MOVWF       FSR2L 
	MOVF        R1, 0 
	ADDWFC      R4, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_error_x+0, 0 
	MOVWF       R0 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_error_x+1, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;PID.C,57 :: 		return p->e;
	MOVLW       60
	ADDWF       FARG_error_p+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_error_p+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
;PID.C,58 :: 		}
L_end_error:
	RETURN      0
; end of _error

_pid:

;PID.C,60 :: 		int16_t pid(PROCESS* p, PID* pid)
;PID.C,65 :: 		Kp= pid->Kp;
	MOVFF       FARG_pid_pid+0, FSR0L
	MOVFF       FARG_pid_pid+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__pid+4 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__pid+5 
	MOVF        FLOC__pid+4, 0 
	MOVWF       PID_Kp+0 
	MOVF        FLOC__pid+5, 0 
	MOVWF       PID_Kp+1 
;PID.C,66 :: 		Ki= pid->Ki;
	MOVLW       2
	ADDWF       FARG_pid_pid+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_pid_pid+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       PID_Ki+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       PID_Ki+1 
;PID.C,67 :: 		Kd= pid->Kd;  // !!
	MOVLW       4
	ADDWF       FARG_pid_pid+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_pid_pid+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       PID_Kd+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       PID_Kd+1 
;PID.C,70 :: 		N=p->N;
	MOVLW       64
	ADDWF       FARG_pid_p+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_pid_p+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__pid+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__pid+1 
	MOVF        FLOC__pid+0, 0 
	MOVWF       pid_N_L0+0 
	MOVF        FLOC__pid+1, 0 
	MOVWF       pid_N_L0+1 
;PID.C,71 :: 		e=p->e;
	MOVLW       60
	ADDWF       FARG_pid_p+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_pid_p+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	CALL        _Int2Double+0, 0
	MOVF        R0, 0 
	MOVWF       pid_e_L0+0 
	MOVF        R1, 0 
	MOVWF       pid_e_L0+1 
	MOVF        R2, 0 
	MOVWF       pid_e_L0+2 
	MOVF        R3, 0 
	MOVWF       pid_e_L0+3 
;PID.C,72 :: 		yk=p->y[N]; yk_1=p->y[N-1]; yk_2=p->y[N-2];
	MOVLW       20
	ADDWF       FARG_pid_p+0, 0 
	MOVWF       R5 
	MOVLW       0
	ADDWFC      FARG_pid_p+1, 0 
	MOVWF       R6 
	MOVF        FLOC__pid+0, 0 
	MOVWF       R0 
	MOVF        FLOC__pid+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR0L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       PID_yk+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       PID_yk+1 
	MOVLW       0
	BTFSC       PID_yk+3, 7 
	MOVLW       255
	MOVWF       PID_yk+2 
	MOVWF       PID_yk+3 
	MOVLW       0
	BTFSC       PID_yk+1, 7 
	MOVLW       255
	MOVWF       PID_yk+2 
	MOVWF       PID_yk+3 
	MOVLW       1
	SUBWF       FLOC__pid+0, 0 
	MOVWF       R3 
	MOVLW       0
	SUBWFB      FLOC__pid+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR0L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       PID_yk_1+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       PID_yk_1+1 
	MOVLW       0
	BTFSC       PID_yk_1+3, 7 
	MOVLW       255
	MOVWF       PID_yk_1+2 
	MOVWF       PID_yk_1+3 
	MOVLW       0
	BTFSC       PID_yk_1+1, 7 
	MOVLW       255
	MOVWF       PID_yk_1+2 
	MOVWF       PID_yk_1+3 
	MOVLW       2
	SUBWF       FLOC__pid+0, 0 
	MOVWF       R3 
	MOVLW       0
	SUBWFB      FLOC__pid+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR0L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       PID_yk_2+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       PID_yk_2+1 
	MOVLW       0
	BTFSC       PID_yk_2+3, 7 
	MOVLW       255
	MOVWF       PID_yk_2+2 
	MOVWF       PID_yk_2+3 
	MOVLW       0
	BTFSC       PID_yk_2+1, 7 
	MOVLW       255
	MOVWF       PID_yk_2+2 
	MOVWF       PID_yk_2+3 
;PID.C,74 :: 		du=Kp*(yk_1-yk)+Ki*e-Kd*(yk-2*yk_1+yk_2);
	MOVF        PID_yk_1+0, 0 
	MOVWF       R0 
	MOVF        PID_yk_1+1, 0 
	MOVWF       R1 
	MOVF        PID_yk_1+2, 0 
	MOVWF       R2 
	MOVF        PID_yk_1+3, 0 
	MOVWF       R3 
	MOVF        PID_yk+0, 0 
	SUBWF       R0, 1 
	MOVF        PID_yk+1, 0 
	SUBWFB      R1, 1 
	MOVF        PID_yk+2, 0 
	SUBWFB      R2, 1 
	MOVF        PID_yk+3, 0 
	SUBWFB      R3, 1 
	MOVF        FLOC__pid+4, 0 
	MOVWF       R4 
	MOVF        FLOC__pid+5, 0 
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Mul_32x32_U+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__pid+4 
	MOVF        R1, 0 
	MOVWF       FLOC__pid+5 
	MOVF        R2, 0 
	MOVWF       FLOC__pid+6 
	MOVF        R3, 0 
	MOVWF       FLOC__pid+7 
	MOVF        PID_Ki+0, 0 
	MOVWF       R0 
	MOVF        PID_Ki+1, 0 
	MOVWF       R1 
	CALL        _Word2Double+0, 0
	MOVF        pid_e_L0+0, 0 
	MOVWF       R4 
	MOVF        pid_e_L0+1, 0 
	MOVWF       R5 
	MOVF        pid_e_L0+2, 0 
	MOVWF       R6 
	MOVF        pid_e_L0+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__pid+0 
	MOVF        R1, 0 
	MOVWF       FLOC__pid+1 
	MOVF        R2, 0 
	MOVWF       FLOC__pid+2 
	MOVF        R3, 0 
	MOVWF       FLOC__pid+3 
	MOVF        FLOC__pid+4, 0 
	MOVWF       R0 
	MOVF        FLOC__pid+5, 0 
	MOVWF       R1 
	MOVF        FLOC__pid+6, 0 
	MOVWF       R2 
	MOVF        FLOC__pid+7, 0 
	MOVWF       R3 
	CALL        _Longint2Double+0, 0
	MOVF        FLOC__pid+0, 0 
	MOVWF       R4 
	MOVF        FLOC__pid+1, 0 
	MOVWF       R5 
	MOVF        FLOC__pid+2, 0 
	MOVWF       R6 
	MOVF        FLOC__pid+3, 0 
	MOVWF       R7 
	CALL        _Add_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__pid+0 
	MOVF        R1, 0 
	MOVWF       FLOC__pid+1 
	MOVF        R2, 0 
	MOVWF       FLOC__pid+2 
	MOVF        R3, 0 
	MOVWF       FLOC__pid+3 
	MOVF        PID_yk_1+0, 0 
	MOVWF       R4 
	MOVF        PID_yk_1+1, 0 
	MOVWF       R5 
	MOVF        PID_yk_1+2, 0 
	MOVWF       R6 
	MOVF        PID_yk_1+3, 0 
	MOVWF       R7 
	RLCF        R4, 1 
	BCF         R4, 0 
	RLCF        R5, 1 
	RLCF        R6, 1 
	RLCF        R7, 1 
	MOVF        PID_yk+0, 0 
	MOVWF       R0 
	MOVF        PID_yk+1, 0 
	MOVWF       R1 
	MOVF        PID_yk+2, 0 
	MOVWF       R2 
	MOVF        PID_yk+3, 0 
	MOVWF       R3 
	MOVF        R4, 0 
	SUBWF       R0, 1 
	MOVF        R5, 0 
	SUBWFB      R1, 1 
	MOVF        R6, 0 
	SUBWFB      R2, 1 
	MOVF        R7, 0 
	SUBWFB      R3, 1 
	MOVF        PID_yk_2+0, 0 
	ADDWF       R0, 1 
	MOVF        PID_yk_2+1, 0 
	ADDWFC      R1, 1 
	MOVF        PID_yk_2+2, 0 
	ADDWFC      R2, 1 
	MOVF        PID_yk_2+3, 0 
	ADDWFC      R3, 1 
	MOVF        PID_Kd+0, 0 
	MOVWF       R4 
	MOVF        PID_Kd+1, 0 
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Mul_32x32_U+0, 0
	CALL        _Longint2Double+0, 0
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	MOVF        FLOC__pid+0, 0 
	MOVWF       R0 
	MOVF        FLOC__pid+1, 0 
	MOVWF       R1 
	MOVF        FLOC__pid+2, 0 
	MOVWF       R2 
	MOVF        FLOC__pid+3, 0 
	MOVWF       R3 
	CALL        _Sub_32x32_FP+0, 0
	CALL        _Double2Longint+0, 0
	MOVF        R0, 0 
	MOVWF       PID_du+0 
	MOVF        R1, 0 
	MOVWF       PID_du+1 
	MOVF        R2, 0 
	MOVWF       PID_du+2 
	MOVF        R3, 0 
	MOVWF       PID_du+3 
;PID.C,75 :: 		du>>=10;
	MOVLW       10
	MOVWF       R4 
	MOVF        R0, 0 
	MOVWF       R7 
	MOVF        R1, 0 
	MOVWF       R8 
	MOVF        R2, 0 
	MOVWF       R9 
	MOVF        R3, 0 
	MOVWF       R10 
	MOVF        R4, 0 
L__pid11:
	BZ          L__pid12
	RRCF        R10, 1 
	RRCF        R9, 1 
	RRCF        R8, 1 
	RRCF        R7, 1 
	BCF         R10, 7 
	BTFSC       R10, 6 
	BSF         R10, 7 
	ADDLW       255
	GOTO        L__pid11
L__pid12:
	MOVF        R7, 0 
	MOVWF       PID_du+0 
	MOVF        R8, 0 
	MOVWF       PID_du+1 
	MOVF        R9, 0 
	MOVWF       PID_du+2 
	MOVF        R10, 0 
	MOVWF       PID_du+3 
;PID.C,76 :: 		p->u[N]=(p->u[N-1])+du;
	MOVLW       40
	ADDWF       FARG_pid_p+0, 0 
	MOVWF       R5 
	MOVLW       0
	ADDWFC      FARG_pid_p+1, 0 
	MOVWF       R6 
	MOVF        pid_N_L0+0, 0 
	MOVWF       R0 
	MOVF        pid_N_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR1L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR1H 
	MOVLW       1
	SUBWF       pid_N_L0+0, 0 
	MOVWF       R3 
	MOVLW       0
	SUBWFB      pid_N_L0+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR0L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	ADDWF       R7, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	ADDWFC      R8, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;PID.C,77 :: 		return p->u[N];
	MOVLW       40
	ADDWF       FARG_pid_p+0, 0 
	MOVWF       R3 
	MOVLW       0
	ADDWFC      FARG_pid_p+1, 0 
	MOVWF       R4 
	MOVF        pid_N_L0+0, 0 
	MOVWF       R0 
	MOVF        pid_N_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R3, 0 
	MOVWF       FSR0L 
	MOVF        R1, 0 
	ADDWFC      R4, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
;PID.C,78 :: 		}
L_end_pid:
	RETURN      0
; end of _pid

_process:

;PID.C,80 :: 		int16_t process(PROCESS* p)
;PID.C,84 :: 		a=p->a;
	MOVLW       8
	ADDWF       FARG_process_p+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_process_p+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__process+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__process+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__process+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       FLOC__process+3 
;PID.C,85 :: 		b=p->b;
	MOVLW       12
	ADDWF       FARG_process_p+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_process_p+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       process_b_L0+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       process_b_L0+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       process_b_L0+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       process_b_L0+3 
;PID.C,86 :: 		N=p->N;
	MOVLW       64
	ADDWF       FARG_process_p+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_process_p+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R7 
	MOVF        POSTINC0+0, 0 
	MOVWF       R8 
	MOVF        R7, 0 
	MOVWF       process_N_L0+0 
	MOVF        R8, 0 
	MOVWF       process_N_L0+1 
;PID.C,87 :: 		p->y[N+1]=a*(p->y[N])+b*(p->u[0]);
	MOVLW       20
	ADDWF       FARG_process_p+0, 0 
	MOVWF       R5 
	MOVLW       0
	ADDWFC      FARG_process_p+1, 0 
	MOVWF       R6 
	MOVLW       1
	ADDWF       R7, 0 
	MOVWF       R3 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FLOC__process+4 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FLOC__process+5 
	MOVF        R7, 0 
	MOVWF       R0 
	MOVF        R8, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R5, 0 
	ADDWF       R0, 1 
	MOVF        R6, 0 
	ADDWFC      R1, 1 
	MOVFF       R0, FSR0L
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	CALL        _Int2Double+0, 0
	MOVF        FLOC__process+0, 0 
	MOVWF       R4 
	MOVF        FLOC__process+1, 0 
	MOVWF       R5 
	MOVF        FLOC__process+2, 0 
	MOVWF       R6 
	MOVF        FLOC__process+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__process+0 
	MOVF        R1, 0 
	MOVWF       FLOC__process+1 
	MOVF        R2, 0 
	MOVWF       FLOC__process+2 
	MOVF        R3, 0 
	MOVWF       FLOC__process+3 
	MOVLW       40
	ADDWF       FARG_process_p+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      FARG_process_p+1, 0 
	MOVWF       R1 
	MOVFF       R0, FSR0L
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	CALL        _Int2Double+0, 0
	MOVF        process_b_L0+0, 0 
	MOVWF       R4 
	MOVF        process_b_L0+1, 0 
	MOVWF       R5 
	MOVF        process_b_L0+2, 0 
	MOVWF       R6 
	MOVF        process_b_L0+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        FLOC__process+0, 0 
	MOVWF       R4 
	MOVF        FLOC__process+1, 0 
	MOVWF       R5 
	MOVF        FLOC__process+2, 0 
	MOVWF       R6 
	MOVF        FLOC__process+3, 0 
	MOVWF       R7 
	CALL        _Add_32x32_FP+0, 0
	CALL        _Double2Int+0, 0
	MOVFF       FLOC__process+4, FSR1L
	MOVFF       FLOC__process+5, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;PID.C,88 :: 		return p->y[N+1];
	MOVLW       20
	ADDWF       FARG_process_p+0, 0 
	MOVWF       R5 
	MOVLW       0
	ADDWFC      FARG_process_p+1, 0 
	MOVWF       R6 
	MOVLW       1
	ADDWF       process_N_L0+0, 0 
	MOVWF       R3 
	MOVLW       0
	ADDWFC      process_N_L0+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR0L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
;PID.C,89 :: 		}
L_end_process:
	RETURN      0
; end of _process

_process_shift:

;PID.C,91 :: 		void process_shift(PROCESS* p)
;PID.C,94 :: 		N=p->N;
	MOVLW       64
	ADDWF       FARG_process_shift_p+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_process_shift_p+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R7 
	MOVF        POSTINC0+0, 0 
	MOVWF       R8 
;PID.C,95 :: 		for(i=0; i<N; i++)
	CLRF        PID_i+0 
	CLRF        PID_i+1 
L_process_shift3:
	MOVF        R8, 0 
	SUBWF       PID_i+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__process_shift15
	MOVF        R7, 0 
	SUBWF       PID_i+0, 0 
L__process_shift15:
	BTFSC       STATUS+0, 0 
	GOTO        L_process_shift4
;PID.C,97 :: 		p->y[i]=p->y[i+1];
	MOVLW       20
	ADDWF       FARG_process_shift_p+0, 0 
	MOVWF       R5 
	MOVLW       0
	ADDWFC      FARG_process_shift_p+1, 0 
	MOVWF       R6 
	MOVF        PID_i+0, 0 
	MOVWF       R0 
	MOVF        PID_i+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR1L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR1H 
	MOVLW       1
	ADDWF       PID_i+0, 0 
	MOVWF       R3 
	MOVLW       0
	ADDWFC      PID_i+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR0L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;PID.C,98 :: 		p->u[i]=p->u[i+1];
	MOVLW       40
	ADDWF       FARG_process_shift_p+0, 0 
	MOVWF       R5 
	MOVLW       0
	ADDWFC      FARG_process_shift_p+1, 0 
	MOVWF       R6 
	MOVF        PID_i+0, 0 
	MOVWF       R0 
	MOVF        PID_i+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR1L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR1H 
	MOVLW       1
	ADDWF       PID_i+0, 0 
	MOVWF       R3 
	MOVLW       0
	ADDWFC      PID_i+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR0L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;PID.C,95 :: 		for(i=0; i<N; i++)
	INFSNZ      PID_i+0, 1 
	INCF        PID_i+1, 1 
;PID.C,99 :: 		}
	GOTO        L_process_shift3
L_process_shift4:
;PID.C,100 :: 		p->y[i]=p->y[i+1];
	MOVLW       20
	ADDWF       FARG_process_shift_p+0, 0 
	MOVWF       R5 
	MOVLW       0
	ADDWFC      FARG_process_shift_p+1, 0 
	MOVWF       R6 
	MOVF        PID_i+0, 0 
	MOVWF       R0 
	MOVF        PID_i+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR1L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR1H 
	MOVLW       1
	ADDWF       PID_i+0, 0 
	MOVWF       R3 
	MOVLW       0
	ADDWFC      PID_i+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R5, 0 
	MOVWF       FSR0L 
	MOVF        R1, 0 
	ADDWFC      R6, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;PID.C,101 :: 		p->eold=p->e;
	MOVLW       62
	ADDWF       FARG_process_shift_p+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_process_shift_p+1, 0 
	MOVWF       FSR1H 
	MOVLW       60
	ADDWF       FARG_process_shift_p+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_process_shift_p+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;PID.C,102 :: 		}
L_end_process_shift:
	RETURN      0
; end of _process_shift
